<!--
  ~ Copyright (c) 2024 LOBA
  ~ 
  ~ Permission is hereby granted, free of charge, to any person obtaining a copy of
  ~ this software and associated documentation files (the "Software"), to deal in
  ~ the Software without restriction, including without limitation the rights to
  ~ use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
  ~ the Software, and to permit persons to whom the Software is furnished to do so,
  ~ subject to the following conditions:
  ~ 
  ~ The above copyright notice and this permission notice shall be included in all
  ~ copies or substantial portions of the Software.
  ~ 
  ~ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  ~ IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
  ~ FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
  ~ COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
  ~ IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  ~ CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  ~ 
  ~ SPDX-License-Identifier: MIT
  ~ 
  ~ Contributors:
  ~     [name] - [contribution]
-->

<template>
    <div class="catalog-details">
        <div class="row">
            <div class="col-md-5">
                <h6>{{ row?.name }}</h6>
                <p>{{ row?.description }}</p>
            </div>
            <div class="col-md-7">
                <div class="row">
                    <div class="col-md-4">
                        <div class="card-property">
                            <div class="card-property-top"><h6>Size</h6><i class="icon-arrow-right"></i></div>
                            <p>Not defined</p>
                        </div>
                    </div>
                    <div class="col-md-4">
                        <div class="card-property">
                            <div class="card-property-top"><h6>Objects</h6><i class="icon-arrow-right"></i></div>
                            <p>4</p>
                        </div>
                    </div>
                    <!-- <div class="col-md-4">
                        <div class="card-property">
                            <div class="card-property-top"><h6>Anonymisation</h6><i class="icon-arrow-right"></i></div>
                            <p>Not anonymised</p>
                        </div>
                    </div> -->
                    <div class="col-md-4">
                        <div class="card-property">
                            <div class="card-property-top"><h6>Terms</h6><i class="icon-arrow-right"></i></div>
                            <p v-if="row?.terms">
                                <span v-for="(term, index) in row?.terms?.slice(0, 3)" :key="term.id">
                                    {{ term?.name }}<span v-if="index < 2">, </span>
                                </span>
                                <span v-if="row?.terms?.length > 3">+ {{ row?.terms?.length - 3 }}</span>
                            </p>
                        </div>
                    </div>
                    <!-- <div class="col-md-4">
                        <div class="card-property">
                            <div class="card-property-top"><h6>Entities</h6><i class="icon-arrow-right"></i></div>
                            <p>21</p>
                        </div>
                    </div>
                    <div class="col-md-4">
                        <div class="card-property">
                            <div class="card-property-top"><h6>Queries</h6><i class="icon-arrow-right"></i></div>
                            <p>124</p>
                        </div>
                    </div> -->
                </div>
            </div>
        </div>
        <div class="row-border">
            <div class="row">
                <div class="col-md-5">
                    <div class="row">
                        <div class="col-md-6">
                            <h6>Created Time</h6>
                            <p>{{ row?.created_at }}</p>
                        </div>
                        <div class="col-md-6">
                            <h6>Last Update</h6>
                            <p>{{ row?.edited_at }}</p>
                        </div>
                    </div>
                </div>
                <div class="col-md-4">
                    <h6>Shared with</h6>
                    <UsersSelectionList />
                </div>
                <div class="col-md-3 item-actions">
                    <button class="button-icon"><i class="icon-share"></i></button>
                    <button class="button-icon"><i class="icon-download"></i></button>
                    <button class="button-icon" @click="deleteDataset"><i class="icon-delete"></i></button> 
                    <button class="button-secondary orange" @click="openEditModal">Edit</button>
                </div>
            </div>
        </div>
    </div>
    <ClientOnly>
        <Teleport to="#modals-container">
            <ModalsModalDelete v-if="showDeleteModal" @toggle="closeDelete" :value="row?.id" type="Dataset" />
        </Teleport>
    </ClientOnly>
</template>
<script setup lang="ts">

// read props datatatable.row
const props = defineProps({
    row: Object
});
const emit = defineEmits(['open-edit-modal', 'refreshData']);
const showDeleteModal = ref(false);

const closeDelete = () => {
    showDeleteModal.value = false;
    emit('refreshData');
};

const deleteDataset = () => {
    showDeleteModal.value = true;
}

const openEditModal = () => {
  // Emit the event with the row data
  emit('open-edit-modal', props.row);
};


</script>